
#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <dirent.h>



void CONF_makeDirectory(void){
  DIR *dir;
  char *homedir=getenv("HOME");
  char temp[500];

  sprintf(temp,"%s/.ladspavst",homedir);
  dir=opendir(temp);

  if(dir==NULL){
    sprintf(temp,"mkdir %s/.ladspavst",homedir);
    system(temp);
  }else{
    closedir(dir);
  }
}


int CONF_checkPluginUpdate(char *name){
  char *homepath=getenv("HOME");
  char *vstpath=getenv("VST_PATH");
  char temp[500];
  struct stat homestat,vststat;

  if(vstpath[strlen(vstpath)-1]=='/'){
    sprintf(temp,"%s%s",vstpath,name);
  }else{
    sprintf(temp,"%s/%s",vstpath,name);
  }
  stat(temp,&vststat);
  if(stat(temp,&homestat)==-1){
    return -1;
  }

  if(S_ISDIR(vststat.st_mode)){
    return -1;
  }

  sprintf(temp,"%s/.ladspavst/%s",homepath,name);
  if(stat(temp,&homestat)==-1){
    return 1;
  }

  if(vststat.st_mtime>=homestat.st_mtime){
    return 1;
  }

  if(homestat.st_size==sizeof(int)){
    return -1;
  }

  return 0;
}


void CONF_updatePlugin(char *name,char *postfix,void *stuff,size_t size){
  char *homepath=getenv("HOME");
  char temp[500];
  FILE *file;
  int dummy=0;

  sprintf(temp,"%s/.ladspavst/%s%s",homepath,name,postfix);

  file=fopen(temp,"w");
  if(file==NULL) return;

  /* If the plugin isnt working, or its not a plugin. */
  if(stuff==NULL){
    stuff=&dummy;
    size=sizeof(int);
  }

  if(fwrite(stuff,size,1,file)==0){
    fclose(file);
    unlink(temp);
    return;
  }

  fclose(file);
}

bool CONF_getPlugin(char *name,char *postfix,void *stuff,size_t size){
  char *homepath=getenv("HOME");
  char temp[500];
  FILE *file;

  sprintf(temp,"%s/.ladspavst/%s%s",homepath,name,postfix);

  file=fopen(temp,"r");
  if(file==NULL) return false;

  if(fread(stuff,size,1,file)==0){
    fclose(file);
    return false;
  }

  fclose(file);

  return true;
}
